/*
 * Copyright (c) 1998 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *       This product includes software developed by the Computer Systems
 *       Engineering Group at Lawrence Berkeley Laboratory.
 * 4. Neither the name of the University nor of the Laboratory may be used
 *    to endorse or promote products derived from this software without
 *    specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * ---------------------------
 *
 * Filename: mb-notkitems.cc
 *   -- Created on Tue Jul 28 1998
 *   -- Author: Yatin Chawathe <yatin@cs.berkeley.edu>
 *
 * Description:
 * 
 */


#ifndef lint
static const char *rcsid = "@(#) $Header: /usr/src/mash/repository/mash/mash-1/mb/mb-notk-items.cc,v 1.1 1998/07/29 18:54:02 yatin Exp $";
#endif



#include "tclcl.h"
#include "mb/mb-items.h"
#include "mb/mb-canv.h"

extern "C" 
{
#include <tk.h>
};


char *PageItem::formatConfigValue(MBCanvas * /*pCanv*/,
				  Tk_ConfigSpec* /*pSpec*/, Bool* /*pFree*/)
{
	fprintf(stderr,
		"Cannot invoke PageItem::formatConfigValue() in smash\n");
	abort();
	return NULL;
}


char *PageItem::getPropsAsStr(MBCanvas* /*pCanv*/)
{
	fprintf(stderr,
		"Cannot invoke PageItem::getPropsAsStr() in smash\n");
	abort();
	return NULL;
}


/* static member function*/
char *PageItem::getProp(const char * /*szTypeName*/, const char * /*szPrefix*/)
{
	fprintf(stderr,
		"Cannot invoke PageItem::getProp() in smash\n");
	abort();
	return NULL;	
}



Bool PageItem::configure(int /*argc*/, const char *const* /*argv*/)
{
	fprintf(stderr,
		"Cannot invoke PageItem::configure() in smash\n");
	abort();
	return true;
}




XColor *
MB_GetColorByValue(XColor *clr)
{
	XColor *newClr = (XColor*) malloc(sizeof(XColor));
	if (newClr) *newClr = *clr;
	return newClr;
}


void
MB_FreeColor(XColor *clr)
{
	if (clr) free(clr);
}


char *
MB_NameOfFont(Tk_Font tkfont)
{
	return (char*) tkfont;
}


Tk_Font
MB_GetFont(const char *string)
{
	return (Tk_Font) strdup(string);
}


void
MB_FreeFont(Tk_Font tkfont)
{
	free((char*) tkfont);
}
