#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "inet.h"
#include "rtp.h"
#include "tclcl.h"
#include "pktbuf.h"
#include "codec/module.h"

class TemporalSelectTargetState {
public:
  
  TemporalSelectTargetState() : target_(0), id_(0), next_(0) {};
  TemporalSelectTargetState(u_int32_t id, Module *target) : target_(target),
    id_(id), next_(0) {};
  Module *target_;
  u_int32_t id_;
  TemporalSelectTargetState *next_;
};

class TemporalSelectModule : public PacketModule {
public:
  TemporalSelectModule() : PacketModule(), target_list_(0), 
    num_targets_(0), callback_(0)  {};

  virtual void recv(pktbuf *pb) = 0;
  virtual void update_target(u_int32_t target_id, 
			     TemporalSelectTargetState *state) = 0;
  virtual TemporalSelectTargetState *register_target(u_int32_t id, 
						     Module *target) = 0;
  virtual void unregister_target(u_int32_t id, 
				 TemporalSelectTargetState *state) = 0;

  void execute_callback(u_int32_t ts);
  int command(int argc, const char*const* argv);

protected:
  void add_state(TemporalSelectTargetState *state);
  void del_state(TemporalSelectTargetState *state);
  TemporalSelectTargetState *get_state_by_id(u_int32_t id);

  TemporalSelectTargetState *target_list_;
  int num_targets_;
  char *callback_;
};
