import WebPoller/Periodic

Class WebPoller/NYTIndex -superclass WebPoller/Periodic

WebPoller/NYTIndex instproc init { boss category } {
	$self instvar boss_ sent_ dir_ category_ rooturl_
	
	set url "http://www.nytimes.com/aponline/index${category}.html"
	set cookie "Cookie {PW=0=*+)0*/,); ID=0=*+)m; RDB=C80201720000005553010264953C400100000000000000; NPACLcacheNYT=AAAATg>AAAAAQ2O6w2WGS6U2TXoxhqM0O83KLqfgCCCHQAAAC4AAAABAAAAJgAAAAEAAAAeAAAABm55dHB1YjcorI8AAAAANy9EDwAAAAAAAAAA>; NPLCNYT=AAAAKg>AAAAAWGSZeGV8nlhmFXSf4D8Df03KQDvgCCCHQAAAAYAAAAAbmF0c3Ux>}"
	set period 60000
	#set period 1
	set dir_ "/tmp"
	set boss_ $boss
	set sent_ ""	
	if [file exists ${dir_}/sent-nyt.txt] {
		set sf [open ${dir_}/sent-nyt.txt r]
		while { [gets $sf line] >= 0 } {
			lappend sent_ $line
		}
		close $sf
	}
	set category_ $category
	set rooturl_ "http://www.nytimes.com/aponline"

	$self next $dir_ $url $cookie
	$self init_timer $period

}


WebPoller/NYTIndex instproc handle { filename path } {
	$self instvar category_ pendings_ boss_ sent_ dir_ rooturl_ pairs_

	# HTML data associated with headlines
	if { $path != "" } {
		set url $path		
		set headline $pairs_($url)
		unset pairs_($url)
		$boss_ send_data $category_ ${rooturl_}/${url} [list "$headline" "$filename"]

	# parse index page with headlines and urls
	} else {

	set buffer [open $filename r]
	set done 0
	while { !$done && [gets $buffer line] >= 0 } {
		if [string match {<NYT_LINKS_ONSITE version="1.0">} $line] {
			# get to the headlines
			while { [gets $buffer line] >= 0 } { 
				if [string match </NYT_LINKS_ONSITE> $line] {
					break
				}
			}

			# first headline has a different format
			while { [gets $buffer line] >= 0 } {
				set tmp1 {<font size=-1 color=#ab0000>Top }
				set tmp2 { Article*</font><br>}
				if [string match ${tmp1}${category_}${tmp2} $line] {
					gets $buffer line
					regexp -nocase {<font size=\+2><A href="([-A-Za-z0-9/. ]+)" >([-A-Za-z0-9.,'$ ]+)</a></font><br>} $line match url headline
					if { [info exists url] && [info exists headline] } {
						lappend pendings_ [list $url $headline]
						break
					}
				}
			}

			# rest of the headlines
			while { [gets $buffer line] >= 0 } {
				if [regexp -nocase {<A HREF="([-A-Za-z0-9/. ]+)" ><b>([^<]+)</b></A>} $line match url headline] {
					if { [info exists url] && [info exists headline] } {
						lappend pendings_ [list $url $headline]
					}
				} elseif [string match {<NYT_FOOTER version="1.0" type="main">} $line] {
					set done 1
					break
				}
			}
		}
	}

	# no articles parsed
	if ![info exists pendings_] {
		puts stderr "Warning: $category_ no articles parsed."
		return
	}
	foreach pair $pendings_ {
		if { [lsearch -exact $sent_ $pair] == -1 } {
			set url [lindex $pair 0]
			set headline [lindex $pair 1]
			set pairs_($url) $headline
			lappend sent_ $pair			
			$self get $url
		}
	}

	if [info exists pendings_] {
		unset pendings_
	}
        }
	
}


