import WebCacheProxy WebCacheControl WebCacheApplication WebCacheApplication/Layer

proc main { args } {

	global cache

	set cacheType [lindex [lindex $args 0] 0]
	set args [lrange [lindex $args 0] 1 end]

	if { $args == "" || "$cacheType" == "-help" } {
		# init will call usage since we pass -help
		puts "cache: \[-layer|-lazy|-base\] \[other-options-listed-below] address"
		set cache [new WebCacheApplication -help]
		delete $cache
		exit 1
	} elseif { "$cacheType" == "-layer" } {
		set cache [new WebCacheApplication/Layer $args]
	} elseif { "$cacheType" == "-lazy" } {
		set cache [new WebCacheApplication/Lazy $args]	
	} elseif { "$cacheType" == "-base" }  {
		set cache [new WebCacheApplication $args]
	}
	
	set proxy [new WebCacheProxy]

	$proxy set cache_ $cache
	$proxy open

	$cache set proxy_ $proxy

	wm withdraw .
}

main $argv









