
Class GR

GR public init { wts num_cluts } {
	$self instvar wts_ num_cluts_
	set wts_ $wts
	set num_cluts_ $num_cluts
}

GR public set_zero_clutmean { src_id i } {
	$self instvar wts_ cluts_

	if ![info exists cluts_(zeromean,$i)] {
		set cluts_(zeromean,$i) [list $src_id]
	} else {
		set cluts_(zeromean,$i) [lappend $cluts_(zeromean,$i) $src_id]
	}
	set num_zero [llength $cluts_(zeromean,$i)]
	# devote 5 percent of bandwidth to zero mean sources
	set mean [expr 0.05 / $num_zero]
	foreach s $cluts_(zeromean,$i) {
		$self set_clutmean $s $i $mean
	}
}

GR public set_clutmean { src_id i mean } {
	$self instvar cluts_

	# try to remove src from zeromean group, if exists there
	if { $mean > 0  && [info exists cluts_(zeromean,$i)] } {
		for {set j 0} {$j < [llength $cluts_(zeromean,$i)]} {incr j} {
			if { "[lindex $cluts_(zeromean,$i) $j]" == "$src_id" } {
				set cluts_(zeromean,$i) [lreplace $cluts_(zeromean,$i) $j $j]
				break
			}
		}
	}
	set cluts_(mean,$i,$src_id) $mean
}

GR public get_clutmean { src_id i { force "no" } } {
	$self instvar wts_ cluts_

	if { ![info exists cluts_(mean,$i,$src_id)] || "$force" == "yes" } {
		set sum 0
		if [info exists cluts_(recv,$i)] {
			foreach recv_id $cluts_(recv,$i) {
				set sum [expr $sum + [$wts_ get_wt $recv_id $src_id]]
			}
			set mean [expr double($sum) / double([llength $cluts_(recv,$i)])]
			set cluts_(mean,$i,$src_id) $mean
		} else {
			# no receivers have shown interest yet in anything
			return 0
		}
	} else {
		set mean $cluts_(mean,$i,$src_id)
	}
	return $mean
}

GR public get_dist_recv_clutmean { recv_id i } {
	$self instvar wts_

	set sum 0
	foreach src_id [$wts_ get_srclist] {
		set wt [$wts_ get_wt $recv_id $src_id]
		set adjmean [$self get_add_adjmean $recv_id $src_id $i]
		#set sum [expr $sum + (($wt - $adjmean) * ($wt - $adjmean))]
		set sum [expr $sum + abs($wt - $adjmean)]
	}
	#set dist [expr sqrt($sum)]
	set dist $sum
	return $dist
}

GR public get_costX { w_0 } {
	$self instvar num_cluts_ cluts_ wts_

	set over_provision 0
	set under_provision 0
	set ideal_provision 0	
	set over_samples ""
	set under_samples ""		
	set src_list [$wts_ get_srclist]
	for {set i 1} {$i <= $num_cluts_} {incr i} {
	if [info exists cluts_(recv,$i)] {
	foreach recv_id $cluts_(recv,$i) {
		set over_s 0
		set under_s 0					
		foreach src_id $src_list {
			set resulted [$self get_clutmean $src_id $i]
			set resulted [$self get_closestwt $w_0 $resulted]
			set requested [$wts_ get_wt $recv_id $src_id]
			set diff [expr abs($requested - $resulted)]
			if { $requested >= $resulted } {
				set under_provision [expr $under_provision + $diff]
				set under_s [expr $under_s + $diff]				
		        }
			if { $requested <= $resulted } {
				set over_provision [expr $over_provision + $diff]
				set over_s [expr $over_s + $diff]				
			}
			set ideal_provision [expr $ideal_provision + $requested]			
	        }
		lappend under_samples $under_s
		lappend over_samples $over_s					
	}
        }
        }
	set under_provision [expr $under_provision / $ideal_provision]
	set over_provision [expr $over_provision / $ideal_provision]
	#puts "ideal: $ideal_provision under: $under_provision over: $over_provision"
	return "[list $under_provision] [list $over_provision] [list $under_samples] [list $over_samples]"
}

GR public get_size { i } {
	$self instvar cluts_ 
	set size 0
	if [info exists cluts_(recv,$i)] {
		set size [llength $cluts_(recv,$i)]
	}
	return $size
}

GR public get_add_adjmean { recv_id src_id i } {
	$self instvar wts_
	
	set clutmean [$self get_clutmean $src_id $i]
	#puts "clutmean: $clutmean"
	set clutsize [$self get_size $i]
	#puts "clutsize: $clutsize"
	set wt [$wts_ get_wt $recv_id $src_id]
	#puts "wt: $wt"
	set adjmean [expr (($clutsize * $clutmean) + $wt) / ($clutsize + 1)]
	#puts "adjmean: $adjmean"
	return $adjmean
}

GR public get_del_adjmean { recv_id src_id i } {
	$self instvar wts_
	
	set clutmean [$self get_clutmean $src_id $i]
	#puts "clutmean: $clutmean"
	set clutsize [$self get_size $i]
	#puts "clutsize: $clutsize"
	set wt [$wts_ get_wt $recv_id $src_id]
	#puts "wt: $wt"
	set adjmean [expr (($clutsize * $clutmean) + $wt) / ($clutsize + 1)]
	#puts "adjmean: $adjmean"
	return $adjmean
}

GR public get_closestwtX { w_0 wt } {
	$self instvar pos_wts_

	if ![info exists pos_wts_] {
		lappend pos_wts_ $w_0 
		set sum $w_0
		set exp 2
		for {set i 0} {$i >= 0} {incr i} {
			set sum [expr $sum + ($w_0 * pow($exp,$i))]
			if { $sum > 1 } {
				break
			} 
			lappend pos_wts_ $sum				
		}
	}
	set min_diff 0xfffffff
	set min_idx -1
	for {set i 0} {$i < [llength $pos_wts_]} {incr i} {
		set c [lindex $pos_wts_ $i]
		set diff [expr abs($c - $wt)]
		if { $diff < $min_diff } {
			set min_diff $diff
			set min_idx $i
		}
	}
	set closest [lindex $pos_wts_ $min_idx]
	return $closest	
}

GR public get_closestwt { w_0 wt } {
	$self instvar pos_wts_

	if ![info exists pos_wts_] {
		lappend pos_wts_ $w_0 
		set sum $w_0
		set exp 2
		for {set i 0} {$i >= 0} {incr i} {
			set sum [expr $sum + ($w_0 * pow($exp,$i))]
			if { $sum > 1 } {
				break
			} 
			lappend pos_wts_ $sum				
		}
	}

	if { $wt < $w_0 } {
		set closest $w_0
	} else {
		set idx [expr [llength $pos_wts_] - 1]
		for {set i 0} {$i < [llength $pos_wts_]} {incr i} {
			set c [lindex $pos_wts_ $i]
			if { $c > $wt } {
				set idx [expr $i - 1]
				break
			}
		}
		set closest [lindex $pos_wts_ $idx]
	}
	return $closest
}

GR public get_num_moves { orig } {
	$self instvar cluts_ num_cluts_
	set num_moves 0
	for {set i 1} {$i <= num_cluts_} {incr i} {
		set c [lindex $orig [expr $i - 1]]
		foreach s $c {
			if { [lsearch $cluts_(recv,$i) $s] == -1 } {
				incr num_moves
			}
		}
	}
	return $num_moves
}

GR public insert { recv_id i } {
	$self instvar cluts_ wts_

	if ![info exists cluts_(recv,$i)] {
		set cluts_(recv,$i) [list $recv_id]
		foreach src_id [$wts_ get_srclist] {
			$self set_clutmean $src_id $i [$wts_ get_wt $recv_id $src_id]
			#puts "cluts_(mean,$i,$src_id): $cluts_(mean,$i,$src_id)"			
		}
	} else {
		foreach src_id [$wts_ get_srclist] {
			$self set_clutmean $src_id $i [$self get_add_adjmean $recv_id $src_id $i]
			#puts "cluts_(mean,$i,$src_id): $cluts_(mean,$i,$src_id)"
		}
		set cluts_(recv,$i) [lappend cluts_(recv,$i) $recv_id]
	}
}

GR public insert_recv { recv_id wts } {
	$self instvar wts_
	$wts_ set_wts $recv_id $wts
}

GR public move { recv_id i j } {
	$self instvar cluts_ wts_	

	foreach src_id [$wts_ get_srclist] {
		$self set_clutmean $src_id $i [$self get_del_adjmean $recv_id $src_id $i]
		$self set_clutmean $src_id $j [$self get_add_adjmean $recv_id $src_id $j]		
	}
	set idx [lsearch $cluts_(recv,$i) $recv_id]
	set cluts_(recv,$i) [lreplace $cluts_(recv,$i) $idx $idx]
	set cluts_(recv,$j) [lappend cluts_(recv,$j) $recv_id]
}

GR public clear { } {
	$self instvar cluts_ num_cluts_

	foreach item [array names cluts_] {
		unset cluts_($item)
	}
}

GR public set_cluts { cluts } {
	$self instvar cluts_
	$self clear
	array set cluts_ $cluts
}

GR public get_cluts { } {
	$self instvar cluts_
	return [array get cluts_]
}

GR public print { } {
	$self instvar cluts_ num_cluts_

	for {set i 1} {$i <= $num_cluts_} {incr i} {
		if [info exists cluts_(recv,$i)
		puts "GR $i: $cluts_(recv,$i)"
	}
	puts "Cost: [$self get_cost 0.001]"
}



