#
# Copyright (c) 1998 Regents of the University of California.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
# 	This product includes software developed by the MASH Research
# 	Group at the University of California Berkeley.
# 4. Neither the name of the University nor of the Research Group may be
#    used to endorse or promote products derived from this software without
#    specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# @(#) $Header: /usr/src/mash/repository/mash/mash-1/tcl/mc/caster.tcl,v 1.5 1998/03/05 21:38:41 yatin Exp $
#


import TCP Observable Application WebProxy

Class CastingDirectorServer -superclass { TCP/Server Observable }

#
# A stub class to bootstrap the applet so that the
# applet can open a socket back to us (java security
# allows sockets only to where the applet originated from)
#
Class CastingProxy -superclass TCP

#
#
#
set castingDirectorProxyPort 2234
set castingDirectorPort 1234

CastingProxy set applet_ "\
<html> \n\
<body> \n\
<applet code=\"RemoteController.class\"> \n\
<param name=\"window\" value=\"documentFrame\"> \n\
<param name=\"port\" value=\"$castingDirectorPort\"> \n\
</applet> \n\
</body> \n\
</html>"

#XXX share this code with WebProxy class
CastingProxy private send_header { len content } {
#XXX each send does a flush
	$self send "HTTP/1.1 200 OK\n"
#	$self send "Date: [exec date -u]"
	$self send "Server: Mashcast Proxy\n"
	$self send "Connection: close\n"
# XXX need:
#Content-Type: text/html
#Last-Modified: Sun, 22 Dec 1996 05:46:43 GMT
#ETag: "1e125-364-32bccb43"

	$self send "Content-type: $content\n"
	$self send "Content-Length: $len\n"
	$self send "Accept-Ranges: bytes\n"
	$self send "\n"
}

CastingProxy instproc send_html s {
	set len [string length $s]
	$self send_header $len text/html
	$self send $s
}

CastingProxy instproc send_java_code code {
	set len [string length $s]
	#XXX text/html seems to work but can't be right
	$self send_header $len text/html
	$self send $s
}

CastingProxy instproc load_file name {
	if ![file readable $name] {
		#XXX
		return "<html>bad request</html>"
	}
	set file [open $name r]
	fconfigure $file -translation binary
	$self instvar data_
	set data_ [read $file 500000]
	close $file
}

import RemoteController

CastingProxy instproc setup_remote_controller {} {
	set i 0
	$self instvar data_
	set data_ ""
	global RemoteController
	while [info exists RemoteController($i)] {
		set data_ "$data_$RemoteController($i)"
		incr i
	}
}

CastingProxy instproc recv s {
	set words [split $s]
	if { [lindex $words 0] == "GET" } {
		#XXX check version
		set url [string trim [lindex $words 1]]
		if { $url == "/applet.html" } {
			$self send_html [CastingProxy set applet_]
		}
		if { $url == "/RemoteController.class" } {
	#
	# XXX hack - otcl methods can't take binary strings, so stuff
	# the data in an instance variable and call send_data without args
	#
			$self setup_remote_controller
			$self instvar data_
			$self send_header [string length $data_] text/html
			$self set_binary
			$self send_data
		}
	}
	# tear down the connection
	delete $self
}

#
# A class that acts as a middleman for web requests
# and manipulates the local browser with "netscape -remote"...
# this needs to be decoupled.
#
Class CastingDirectorServer -superclass { TCP/Server Observable }

CastingDirectorServer instproc init { port } {
	$self next
#	$self instvar multicast_
#	set multicast_ $webcache
	$self open $port
}

Class CastingDirector -superclass TCP

#
# Server should keep list of casters and update each caster...
# (i.e., we can support multiple browsers I think)
#
CastingDirectorServer instproc create_channel chan {
	set o [new CastingDirector]
	$o open $chan
	return $o
}

#XXX need to catch shutdown
CastingDirector public init { } {
	#XXX
	$self user_hook    
}

#
# Called from TCP module when we receive data on our socket, which
# consists of caster commands from the Java applet running in
# the from the mash-cast page in a web browser.  It normally
# doesn't say anything, i.e., we normally tell it what to do.
#
CastingDirector instproc recv s {
	puts stderr $s
}

