#
# Copyright (c) @ Regents of the University of California.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
# 	This product includes software developed by the MASH Research
# 	Group at the University of California Berkeley.
# 4. Neither the name of the University nor of the Research Group may be
#    used to endorse or promote products derived from this software without
#    specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# @(#) $Header: /usr/src/mash/repository/mash/mash-1/tcl/rtpgw/session-rtp-rtpgw.tcl,v 1.1 1998/12/17 00:08:11 weitsang Exp $
#

Session/RTP/RTPGW instproc init { agent } {
	$self next
	
	$self instvar dh_ ch_ agent_ netmgr_
	set agent_ $agent
	set h [new Module/DataHandler]
	$self data-handler $h
	set dh_ $h
		
	set h [new Module/ControlHandler]
	$self ctrl-handler $h
	set ch_ $h
	
	set netmgr_ ""
}


Session/RTP/RTPGW instproc reset ab {
	$self instvar agent_ netmgr_

	set nm [new NetworkManager $ab $self $agent_]

	if { $netmgr_ != "" } {
		delete $netmgr_
	}
	set netmgr_ $nm

	# Turn on loopback since multiple gateways could be running on same 
	# host
	set i 0
	set n [$nm nchan]
	while { $i < $n } {
		set net [$nm set net_($i)]
		set dn [$net data-net]
		set cn [$net ctrl-net]
		$dn loopback 1
		$cn loopback 1
		incr i
	}
}

Session/RTP/RTPGW instproc destroy {} {
	$self instvar dh_ ch_ netmgr_
	delete $dh_
	delete $ch_
	if { $netmgr_ != "" } {
		delete $netmgr_
	}
	
	$self next
}

